# -*- coding: utf-8 -*-
from setuphelpers import *
from waptutils import fileutcdate
import json

r"""
Using the official Microsoft script: 
https://techcommunity.microsoft.com/t5/microsoft-endpoint-manager-blog/understanding-readiness-for-windows-11-with-microsoft-endpoint/ba-p/2770866

Graphical equivalent (not used):
https://blogs.windows.com/windows-insider/2021/08/27/update-on-windows-11-minimum-system-requirements-and-the-pc-health-check-app/
https://aka.ms/GetPCHealthCheckApp

return_code_list = {
    "returnCode":    "Definition",
    -2:              "FAILED TO RUN – the script encountered an error",
    -1:              "UNDETERMINED – one or more of the hardware requirement checks failed to execute properly",
    0:               "CAPABLE – the device meets all assessed Windows 11 hardware requirements",
    1:               "NOT CAPABLE – the device does not meet one or more of the assessed Windows 11 hardware requirements",
}

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
script_file_name = "HardwareReadiness.ps1"


def install():
    # Copying script
    print("Copying: %s to: %s" % (script_file_name, persistent_dir))
    filecopyto(script_file_name, persistent_dir)


def audit():
    # Declaring local variables
    return_audit = "OK"
    script_file_path = makepath(persistent_dir, script_file_name)

    # Get the capabilities
    return_ps1 = json.loads(get_powershell_str('&"%s"' % script_file_path))
    return_result = return_ps1.get("returnResult")

    # Auditing package
    print("Auditing: %s" % control.package)

    # Add value on local database
    WAPT.write_audit_data_if_changed("windows11-requirements", "logs", return_ps1)
    WAPT.write_audit_data_if_changed("windows11-requirements", "result", return_result)
    print(json.dumps(return_ps1, indent=4))
    # print("This Device result: %s" % return_result)

    # Return result
    return return_audit
