# -*- coding: utf-8 -*-
from setuphelpers import *
from waptutils import fileutcdate
import json


script_file_name = "HardwareReadiness.ps1"


def update_package():
    # Define local variable
    result = False

    # Get script
    wget("https://aka.ms/HWReadinessScript", script_file_name)

    # Check if newer version
    filedate = fileutcdate(script_file_name)
    version = f"{filedate.year}.{filedate.month}.{filedate.day}"

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return result
